#INCLUDE "dcdialog.ch"
#INCLUDE "appevent.CH"

FUNCTION Main()

LOCAL GetList[0], GetOptions, oMenuBar, oSubMenu, oDlg

DCGETOPTIONS ;
   EVAL {|o|CreateTitleBar(o)}

DC_GetOptDefault(GetOptions)

DCMENUBAR oMenuBar

  DCSUBMENU oSubMenu PROMPT 'Window' PARENT oMenuBar

    DCMENUITEM 'Open a Window' PARENT oSubMenu ;
      ACTION {|o|o := Thread():new(), o:start({||OpenWindow(oDlg)})}

DCGETOPTIONS ;
   WINDOWWIDTH 800 ;
   WINDOWHEIGHT 600

DCREAD GUI TITLE 'Buttons on Title Bar' OPTIONS GetOptions ;
   PARENT @oDlg SETAPPWINDOW

RETURN nil

* ----------

STATIC FUNCTION OpenWindow( oDlg )

LOCAL GetList[0], GetOptions, i

FOR i := 1 TO 10
  @ i,0 DCSAY 'This is line ' + Alltrim(Str(i)) FONT '10.Lucida Console' SAYSIZE 50
NEXT

DCREAD GUI TITLE 'Test Window' OPTIONS GetOptions APPWINDOW oDlg:drawingArea

RETURN nil

* ----------

PROC appsys ; RETURN

* ----------

STATIC FUNCTION CreateTitleBar( oDlg )

LOCAL GetList[0], oButtonDlg, oDrawingArea, oAppDeskTop := AppDeskTop(), ;
      oConfig, oButton, oParent

IF oDlg:parent == AppDeskTop()
  oParent := oDlg:parent
ELSE
  oParent := oDlg:parent:parent
ENDIF

oConfig := DC_XbpPushButtonXPConfig():new()
oConfig:bgColor := GRA_CLR_DARKGRAY
oConfig:fgColor := GRA_CLR_WHITE
oConfig:radius := 0

@ 100,100 DCDIALOG oButtonDlg DRAWINGAREA oDrawingArea ;
          NOTITLEBAR NOMINBUTTON NOMAXBUTTON ;
          BORDER XBPDLG_THINBORDER SIZE 35,20 PIXEL ;
          PARENT oParent OWNER oDlg PREEVAL {|o|o:moveWithOwner := .t.} ;
          EVAL {|o|o:drawingArea:setColorBG(XBPSYSCLR_TRANSPARENT), ;
                   oDlg:setButtons(o), ;
                   oDlg:setOffset(160)}

@ 0,0 DCPUSHBUTTONXP CAPTION 'Help' SIZE 33,18 PIXEL PARENT oDrawingArea CONFIG oConfig ;
      ACTION {||MsgBox('There is no Help for you!')} ;
      OBJECT oButton

DCREAD GUI EXIT PARENT oAppDeskTop

oButton:invalidateRect()
PostAppEvent(xbeP_Resize,,,oDlg)
DC_CompleteEvents()

IF oParent # AppDeskTop()
  oDlg:killDisplayFocus := {||oButtonDlg:hide()}
  oDlg:setDisplayFocus := {||oButtonDlg:show()}
ENDIF

RETURN nil


